


#ifndef __CreateTemplate_H
#define __CreateTemplate_H


#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "ShapeTriangleSoup.h"

#include "STemplate.h"
#include "VisShapeTemplate.h"
#include "AppScreenshots.h"
#include "TMatch.h"
#include "RendererOSMesa.h"
#include "TMatchAlg.h"
#include "STemplateNode.h"
#include "InitWordNet.h"

#include "CreateTemplate.h"
#include "AutoSegment.h"

void ReadModelNames(VKStringList & store, const VKString & filename);
STemplate * SingleTemplate(ModelDatabase * db, const VKString & mName, const VKString & geomName,
						   const VKString & labelsName, bool trustLabels, double useMeshThresh,
						   bool splitLabelsIntoCC, const VKString & geomValueFile);

STemplate * InitTemplate(const VKString & topologyFile, const VKString & trainGeomName,
						 const VKString & trainLabelsName, ModelDatabase * db);

GeomShape * ReadModelGeometry(ModelDatabase * db, const VKString & mName, const VKString & geomName,
							  bool readManifold, const VKString & geomValue = "none",
							  const VKString & geomValueFile = "none");
bool Equivalent(const VKString & label1, const VKString & label2, std::map<VKString, int> & label2ListID);
void ReadEquivalentLabels(const VKString & equivFile,
						  std::vector<VKStringList> & equivalenceList, std::map<VKString, int> & label2ListID);
VKString MainName(const VKString & label,
				  std::vector<VKStringList> & equivalenceList, std::map<VKString, int> & label2ListID);
void EvalMatching(ModelDatabase * db, const TMatch * matching, const VKString & filename, const VKString & equivLabels);
void WriteAlignedModel(const TMatch * match, const VKString & filename);
void WriteTemplateMetaData(const STemplate * tmplt, const VKString & filename);

void WriteLabelsExternal(const TMatch * match, const VKString & dirName);

#endif