#include "InitWordNet.h"

STemplate * ReadTemplateFromDir(const VKString & inDir)
{
	std::cout<<"Read Tempalte from Dir:"<<inDir.c_str()<<std::endl;
	STemplate * st = new STemplate(NULL);
	PartBox rootEllipsoid(st->GetAllParts());
	R3Triad xyz(R3Vector(1, 0, 0), R3Vector(0, 1, 0), R3Vector(0, 0, 1));
	rootEllipsoid.InitBox(R3Point(0,0,0), xyz, R3Vector(1, 1, 1), 0);
	
	st->InitAndAddNewNode(-1, "Root", rootEllipsoid, 0);
	
	// go over all text files
	VKString partsDir = inDir+"/Canonical/";
	VKStringList allfiles = FileManagement::ListAllFiles(partsDir.c_str());
	
	for (int i=0; i<allfiles.count(); i++)
	{
		if (allfiles[i].endsWith(".txt") && !allfiles[i].startsWith("."))
		{
			std::cout<<"Reading "<<allfiles[i].c_str()<<std::endl;
			std::ifstream textStream((partsDir+"/"+allfiles[i]).c_str());
			assert(textStream.is_open());
			VKString label;
			label.readLine(textStream);
			label = label.replace(" ", "").replace("\n", "");
			while (!textStream.eof())
			{
				int nparts, nmodels;
				textStream>>nparts>>nmodels;
				if (textStream.eof())
					break;
				//std::cout<<"  NParts: "<<nparts<<" NModels: "<<nmodels<<std::endl;
				
				for (int pid = 0; pid < nparts; pid++)
				{
					double xmin, ymin, zmin, xmax, ymax, zmax;
					textStream>>xmin>>ymin>>zmin>>xmax>>ymax>>zmax;
					R3Point pmin(xmin, ymin, zmin);
					R3Point pmax(xmax, ymax, zmax);
					pmin *= 3.;
					pmax *= 3.;
					PartBox currPart(st->GetAllParts());
					currPart.InitBox((pmin+pmax)/2, xyz, (pmax-pmin)/2, 0);
					assert(false);
					if ((label=="seat" && nparts==1) || (label == "leg" && nparts==4)
						|| (label=="back" && nparts==1))
					{
						//std::cout<<"     Adding: "<<label.c_str()<<" "<<pid<<" / "<<nparts<<std::endl;
						st->InitAndAddNewNode(0, label, currPart, 0);
					}
				}
			}
			textStream.close();
		}
	}
	
	PartBox nullGeom(st->GetAllParts());
	nullGeom.InitNull();
	st->InitAndAddNewNode(0, "NullNode", nullGeom, 0);
	return st;
}


class PartConfig
{
	public:
		
		bool SameConfig(const PartConfig & other);
	
		std::map<VKString, int> m_Config;
		VKStringList m_ModelsWithConfig;
};

STemplate * CreateTemplateFromWordnetAnalysis(ModelDatabase * db, const VKString & wordNetFile)
{
	
}



