
#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"
#include "BasicNumerical.h"

#include "RendererOSMesa.h"
#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "AppScreenshots.h"
#include "VisShapeTemplate.h"

#include "STemplate.h"
#include "TMatch.h"
#include "TMatchEnergy.h"
#include "TMatchAlg.h"
#include "PartOfEdge.h"
#include "ConsistentPartsAlg.h"
#include "STemplateNode.h"


#ifndef __EvalCorrs_H
#define __EvalCorrs_H

void EvalCorrs(STemplate * st, const VKString & fileList, const VKString & methodDir,
			   const VKString & dbDir, const VKString & outIntegratedCorrs, bool debugVis);
double * EvalCorrsCDF(const double * evalCorrsPDF, int nSteps);
void EvalCorrsReadFeatPnts(ShapeMesh * mesh, const VKString & filename, std::vector<ShapePoint *> & gt);
void EvalCorrsAddPDF(double error, double * pdfPnts, int nSteps, double minErr, double maxErr);

void EvalFuzzyCorrs(const VKString & fuzzyCorrsFile, const VKString & fileList,
					const VKString & dbDir, const VKString & outIntegratedCorrs, bool debugVis);
void ReadFuzzyCorrsFile(const VKString & fuzzyCorrsFile, const std::vector<ShapeMesh * > & inputMeshes,
						std::vector<ShapePointCloud *> & fuzzyPnts, std::map<int, R3Point> * v2vmaps);

void ReadCoAlignedPoints(const VKString & coAlignedPntsFile, std::vector<std::vector<R3Point> > & coAlignedPoints);
TMatchEnergy * ReadMatch(STemplate * st, const VKString & matchFile, const VKString & dbDir, const VKString & methodDir);

double GetMeshRadius(const ShapeMesh * mesh);

#endif

