#include "VKStringList.h"

void VKStringList::Sort()
{
	std::sort(m_Data.begin(), m_Data.end());
}

void VKStringList::WriteList(FILE * file, const VKStringList & strList)
{
	int count = strList.count();
	fwrite(&count, sizeof(int), 1, file);
	for (int i=0; i<count; i++)
		VKString::WriteString(((VKStringList &)strList)[i], file);
}

void VKStringList::ReadList(FILE* file, VKStringList & strList)
{
	int count;
	fread(&count, sizeof(int), 1, file);
	for (int i=0; i<count; i++)
		strList.push_back(VKString::ReadString(file));
}

void VKStringList::WriteList(FILE * file, const std::vector<int> & list)
{
	int count = (int)list.size();
	fwrite(&count, sizeof(int), 1, file);
	for (int i=0; i<count; i++)
	{
		int v = list[i];
		fwrite(&v, sizeof(int), 1, file);
	}
}

void VKStringList::ReadList(FILE * file, std::vector<int> & list)
{
	int count;
	fread(&count, sizeof(int), 1, file);
	int v;
	for (int i=0; i<count; i++)
	{
		fread(&v, sizeof(int), 1, file);
		list.push_back(v);
	}
}

void VKStringList::WriteList(FILE * file, const std::vector<double> & list)
{
	int count = (int)list.size();
	fwrite(&count, sizeof(int), 1, file);
	for (int i=0; i<count; i++)
	{
		double v = list[i];
		fwrite(&v, sizeof(double), 1, file);
	}
}

void VKStringList::ReadList(FILE * file, std::vector<double> & list)
{
	int count;
	fread(&count, sizeof(int), 1, file);
	double v;
	for (int i=0; i<count; i++)
	{
		fread(&v, sizeof(double), 1, file);
		list.push_back(v);
	}
}

VKStringList::VKStringList()
{
}

VKStringList::VKStringList(const VKStringList & other)
{
	m_Data = other.m_Data;
}


void VKStringList::push_back(VKString obj)
{
	m_Data.push_back(obj);
}

VKString & VKStringList::operator[](int i)
{
	return m_Data[i];
}

const VKString & VKStringList::operator[](int i) const
{
	return m_Data[i];
}

void VKStringList::clear()
{
	m_Data.clear();
}

int VKStringList::count() const
{
	return (int)m_Data.size();
}

bool VKStringList::contains(const VKString & trg) const
{
	for (int i=0; i<(int)m_Data.size(); i++)
	{
		if (m_Data[i]==trg)
			return true;
	}
	return false;
}

int VKStringList::containsGetID(const VKString & trg) const
{
	for (int i=0; i<(int)m_Data.size(); i++)
	{
		if (m_Data[i]==trg)
			return i;
	}
	return -1;
}

VKString VKStringList::join(const VKString & sep) const
{
	VKString joinedStr;
	for (int i=0; i<(int)m_Data.size(); i++)
		joinedStr += m_Data[i] + (i<((int)m_Data.size()-1) ? sep : "");
	return joinedStr;
}

void VKStringList::remove(int elementID)
{
	assert(elementID<(int)m_Data.size() && elementID>=0);
	m_Data.erase(m_Data.begin()+elementID);
}

void VKStringList::remove(const VKString & trg)
{
	for (int i=0; i<(int)m_Data.size(); i++)
	{
		if (m_Data[i]==trg)
		{
			remove(i);
			break;
		}
	}
}
