#include "VKString.h"
#include <algorithm>
#ifndef __VKSTRINGLIST_H
#define __VKSTRINGLIST_H

class VKStringList
{
	friend class VKString;
	public:
		VKStringList();
		VKStringList(const VKStringList & other);
	
		void Sort();
	
	// Qt stuff
		void push_back(VKString obj);
		VKString & operator[](int i);
		const VKString & operator[](int i) const;
		void clear();
		int count() const;
		bool contains(const VKString & trg) const;
		int containsGetID(const VKString & trg) const;
		VKString join(const VKString&  sep) const;
		void remove(int elementID);
		void remove(const VKString & trg);	

		static void WriteList(FILE * file, const VKStringList & strList);
		static void ReadList(FILE* file, VKStringList & strList);
	
		static void WriteList(FILE * file, const std::vector<int> & list);
		static void ReadList(FILE * file, std::vector<int> & list);
		static void WriteList(FILE * file, const std::vector<double> & list);
		static void ReadList(FILE * file, std::vector<double> & list);

	protected:
		std::vector<VKString> m_Data;
};

#endif

