/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "CorrValue.h"

CorrValue::CorrValue(ShapeCorrs * shapeCorrs,
					 const VKString & corrValName)
{
	m_pShapeCorrs = shapeCorrs;
	m_sCorrValName = corrValName;
}

CorrValue::~CorrValue()
{
	
}

const VKString & CorrValue::CorrValueName() const
{
	return m_sCorrValName;
}

void CorrValue::WriteCorrVals(const VKString & filename)
{
	FILE * file = fopen(filename.c_str(), "wb");
	WriteCorrVals(file);
	fclose(file);
}

void CorrValue::ReadCorrVals(const VKString & filename)
{
	FILE * file = fopen(filename.c_str(), "rb");
	ReadCorrVals(file);
	fclose(file);	
}

void CorrValue::WriteCorrVals(FILE * file)
{
	std::cout<<"[WARNING] WriteShapeCorrs not implemented in the child"<<std::endl;
}

void CorrValue::ReadCorrVals(FILE * file)
{
	std::cout<<"[WARNING] ReadShapeCorrs not implemented in the child"<<std::endl;
}

