/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeDistance_H
#define __ShapeDistance_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "GeomShape.h"
#include "ShapePoint.h"

class DistEuclidean;
class DistGeodesicDijkstra;

class ShapeDistance
{
	public:
		static VKString m_sDefaultEuclidean;
		static VKString m_sDefaultGeodesic;
	
		ShapeDistance(GeomShape * shape, const VKString & metricName = "none");
		virtual ~ShapeDistance();
	
		virtual DistEuclidean * SafeCastToEuclidean();
		virtual DistGeodesicDijkstra * SafeCastToGeodesic();
	
		const VKString & MetricName();
		virtual const GeomShape * Geometry();
		virtual bool SameGeometry(GeomShape * geom);
	
		virtual double NormalizedDistance(double distance) const = 0;
		virtual double NormalizedDistance(const ShapePoint & p1, 
										  const ShapePoint & p2) const = 0;
//		virtual void NearestNeighborhood(const ShapePoint & p, 
//										 double distanceThreshold,
//										 std::vector<ShapePoint> * neighborhood,
//										 std::vector<double> * normDists = NULL) const = 0;
//		virtual ShapePoint NearestNeighbor(const ShapePoint & p, 
//										   double* normDists = NULL) const = 0;
	
	protected:
		GeomShape * m_pShape;
		VKString m_sDistMetricName;
};

#endif

