/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeImg_H
#define __ShapeImg_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "GeomShape.h"

/**
 * Thumbnails
 */ 
class ShapeImg : public GeomShape
{
	public:	
		ShapeImg(const VKString & geomName = "none", Model3D * model = NULL);
		virtual ShapeImg * SafeCastToImg();
	
		virtual void FreeMemory();
		virtual void SetSrcFile(const VKString & filename);
	
		virtual void SetImg(R2Image * img);
		virtual R2Image * GetImage();
		virtual void WriteGeometryFile(const VKString & geomFile);
		virtual void ReadGeometryFile(const VKString & geomFile);
		
	protected:
		R2Image * m_pImage;
};

#endif

