/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __RendererGLUT_H
#define __RendererGLUT_H

#include <fstream>
#include <sstream>

#include "VisWindow.h"
#include "VKString.h"
#include "ParamParser.h"

#include "OpenGLHeaders.h"

using namespace std;

void GLUTRedraw();
void GLUTResize(int w, int h);
void GLUTKeyboard(unsigned char key, int x, int y);
void GLUTSpecial(int key, int x, int y);
void GLUTMouse(int button, int state, int x, int y);
void GLUTMotion(int x, int y);

/**
 * GLUT implementation of UI winodw.
 */
class RendererGLUT : public VisWindowRenderer
{
	public:
		RendererGLUT(int argc, char ** argv, VisWindow * window);

		virtual void RenderText(R2Point pnt, const VKString & text, 
								double r, double g, double b, TextSize size) const;
		virtual void RenderText(R3Point pnt, const VKString & text, 
								double r, double g, double b, TextSize size) const;
		virtual void TerminateWindow();
		virtual void UpdateScreen();
		
		int GetSpecialKeys();
		void GLUTRedrawCallback();
		void GLUTResizeCallback(int w, int h);
		void GLUTKeyboardCallback(unsigned char key, int x, int y);
		void GLUTSpecialCallback(int key, int x, int y);
		void GLUTMouseCallback(int button, int state, int x, int y);
		void GLUTMotionCallback(int x, int y);
			
		static RendererGLUT * s_MainGLUTWindow;
	
	protected:
		int m_GLUTwindowID;
		int m_GLUTmouse[2];
		int m_GLUTmodifiers;

};

#endif
