/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __DBApp_H
#define __DBApp_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>
#include "OpenGLHeaders.h"

#include "DatabaseVisWindow.h"

class DBApp
{
	public:
		DBApp(ModelDatabase * db = NULL, DBCorrs * dbCorrs = NULL);
		virtual ~DBApp();
	
	// interface functions for visualization: return true if 'captured'
		virtual bool KeyPressed(DatabaseVisWindow * window, const char key, int mouseX, int mouseY);
		virtual bool MouseButtonEvent(DatabaseVisWindow * window, 
									  int x, int y, VisWindow::MouseButton mouseButtonID, 
									  VisWindow::MouseButtonState newState);
		virtual bool MouseMotionEvent(DatabaseVisWindow * window, int x, int y, int dx, int dy);
		virtual bool Draw(DatabaseVisWindow * window);

		virtual void SetScreenshotType(const VKString & sName, int value);
		virtual int GetRenderingFlags() const;
		virtual void SetRenderingFlags(int flags);
		virtual void SetRenderingFlag(int flag, bool value);
		virtual void Toggle(int flag);
		virtual bool IsFlagSet(int flag) const;
		virtual void ToggleDisable();

	protected:
		ModelDatabase * m_pDB;
		DBCorrs * m_pDBCorrs;
		int m_iVisFlags;
		bool m_bDisable;
};

#endif

