#!/usr/bin/python

##
# Labels all models in a collection
#

import os, sys;
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scripts/largescale/"))
import mydb;

workDir = "scratch";
readTmplt = "none";
reference = "none";

if len(sys.argv)>=2:
	outTmplt = sys.argv[1];
	i = 2;
	while i<len(sys.argv):
		if (sys.argv[i]=="-readTmplt"):
			i = i + 1;
			readTmplt = sys.argv[i];
		elif (sys.argv[i]=="-reference"):
			i = i + 1;
			reference = sys.argv[i];
		elif (sys.argv[i]=="-workDir"):
			i = i + 1;
			workDir = sys.argv[i];
		i = i + 1;

else:
	print("Usage:")
	print("    createInitTmplt.py output.tmplt [optional]");
	print("Optional:");
	print("    -readTmplt input.tmplt - set initial template");
	print("    -reference shape.off - set initial model");
	print("    -workDir dir - working directory (default=./scratch)");
	exit()


if reference!="none":
	mFile = mydb.NameOnly(reference);
	if (len(mFile) < 4 or mFile[-4:]!=".off"):
		print("[WARNING] Cannot interpret file name "+mFile);
		exit();
	mName = mFile[:-4];

	if os.path.isdir(workDir):
		if not os.path.isfile(workDir+"/mydb/Models/Geometry/"+mName+".ascii.off"):
			os.system("rm -r -f "+workDir);
			os.system("mkdir "+workDir);
	else:
		os.system("mkdir "+workDir);
	os.system("cp "+reference+" "+workDir+"/"+mName+".off");
	os.system("./scripts/largescale/createFromDir.py "+workDir+" "+workDir);
else:
	mName = "none";

cmd = "./scripts/experiment/createTemplate.py "+outTmplt+" -createMode manual ";
cmd += "-readTmplt "+readTmplt+" -vis -refDB "+workDir+" -refMdl "+mName+" ";

os.system(cmd);
	


