#!/usr/bin/python

##########
# Export analysis results to a more readable format (see TemplateParse.cpp)
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, random
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scripts/largescale/"));
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scripts/experiment/"));
import mydb, expdb

if len(sys.argv)>=4:
	prepared_dir = sys.argv[1]
	results_dir = sys.argv[2]
	export_dir = sys.argv[3]
else:
	print("Usage:")
	print("   exportAnalysis.py prepared_dir results_dir export_dir");
	print("Note: ")
	print("   prepared_dir is sometimes printed to working directory\n        and looks like this \"prepared_dir/mydb/Models/...\"");
	print("   results_dir is sometimes printed to output directory\n          and looks like this \"results_dir_GenFinal\" ");
	exit()

dbDir = mydb.MyDBDir(prepared_dir);

if not os.path.isdir(export_dir):
	os.system("mkdir "+export_dir);

if not os.path.isdir(export_dir+"/img_matches"):
	os.system("mkdir "+export_dir+"/img_matches");
if not os.path.isdir(export_dir+"/img_models"):
	os.system("mkdir "+export_dir+"/img_models");
if not os.path.isdir(export_dir+"/matches"):
	os.system("mkdir "+export_dir+"/matches");
#if not os.path.isdir(export_dir+"/meshes"):
#	os.system("mkdir "+export_dir+"/meshes");
if not os.path.isdir(export_dir+"/coaligned"):
	os.system("mkdir "+export_dir+"/coaligned");

tmplt = results_dir+"/main.tmplt";


# parse template
cmd = "./TemplateParse -readTmplt "+tmplt +" -writeTmplt "+export_dir+"/main.tmplt "
os.system(cmd);

# per model results
#mList = mydb.ListModels(keyword);
if not os.path.isfile(results_dir+"/LabeledModels.txt"):
	cmd = "./scripts/evolution/aggLabelStats.py "+prepared_dir+" "+results_dir+" LabeledModels.txt -outDirIsAbsolute ";
	os.system(cmd);

mList = expdb.readModelList(results_dir+"/LabeledModels.txt");
counter = 0;
for mInst in mList:
	mName = mInst.mname;
	counter = counter + 1;
	if counter % 20 == 0:
		print("Processing "+str(counter)+" / "+str(len(mList)));

	# parse matchings
	matchFile = results_dir+"/"+mName+"/match.match.bin";
	cmd = "./TemplateParse -readTmplt "+tmplt +" -readMatch "+results_dir+"/"+mName+"/match.match.bin ";
	cmd += "-dbDir "+dbDir+" -model "+mName+" -writeMatch "+export_dir+"/matches/"+mName+".match ";
	cmd += "-writeCoAligned "+export_dir+"/coaligned/"+mName+".pnts; ";
	
	# copy images
	cmd += "cp "+results_dir+"/"+mName+"/textured.jpg "+export_dir+"/img_models/"+mName+".jpg; ";
	cmd += "cp "+results_dir+"/"+mName+"/match.deformed.jpg "+export_dir+"/img_matches/"+mName+".jpg; ";

#	# copy meshes
#	outAscii = export_dir+"/meshes/"+mName+".off";
#	cmd += "./CreateGeometry "+dbDir+" -outGeomName "+outAscii+" -outGeomIsFile -model "+mName+" -type ASCIIOff -write; ";

	mydb.ExecuteNoWait(cmd, mName);



