#!/usr/bin/python

##########
# aggregates labeling stats
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, time
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../largescale/"))
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../experiment/"))
import mydb, expdb

if len(sys.argv)==2:
	datasetPrefix = sys.argv[1];
	methodDir = mydb.CurrMethod();
elif len(sys.argv)==3:
	datasetPrefix = sys.argv[1];
	methodDir = sys.argv[2];
else:
	print("Usage:");
	print("   "+sys.argv[0]+" datasetPrefix=(PSB,SD,CoSegB) methodDir");
	exit();

# PSB_eval.txt - average accuracy, list all classes
allDatasetsDir = mydb.Webpage("")
keywords = [];
nCorrect = 0;
nPnts	 = 0;
nModels  = 0;

tInfoKeywords = [];
nTotalBoxPrim = 0;
nTotalMeshPrim = 0;
nTotalPrim = 0;
nAveErr = 0;

for keyword in os.listdir(allDatasetsDir):
	if (os.path.isdir(mydb.Webpage(keyword)) and keyword[:len(datasetPrefix)]==datasetPrefix):
		evalFile = mydb.Webpage(keyword)+"/Templates/"+methodDir+"/eval_faces.txt"
		if os.path.isdir(mydb.Webpage(keyword)+"/Templates/"+methodDir) and (not os.path.isfile(evalFile)):
			cmd="./scripts/experiment/aggLabelStats.py "+keyword+" "+methodDir;
			os.system(cmd);
		if  (not os.path.isfile(evalFile)):
			print "[WARNING] Could not find evaluation for "+keyword;
			continue;
		firstLine = file(evalFile, "r").readline().split(" ");
		nCorrect += int(firstLine[1]);
		nPnts += int(firstLine[3]);
		nModels += int(firstLine[4]);
		evalScore = float(firstLine[1]) / float(firstLine[3]);
		keywords.append((keyword, int(firstLine[1]), int(firstLine[3]), int(firstLine[4]), evalScore));

		tInfoFile = mydb.Webpage(keyword)+"/Templates/"+methodDir+"/tSelfInfo.txt";
		if os.path.isfile(tInfoFile):
			lines = file(tInfoFile).readlines();
			lines.pop(0);
			nBox = 0;
			nMesh = 0;
			nTotal = 0;
			fErr = 0;
			for line in lines:
				line = line.split(" ");
				if (line[0][-5:]!="_root" and line[0][:-5]!="NULL"):
					nBox = nBox + int(line[1]);
					nMesh = nMesh + int(line[2]);
					nTotal = nTotal + int(line[3]);
					fErr = fErr + float(line[4]);
			nTotalBoxPrim = nTotalBoxPrim + nBox;
			nTotalMeshPrim = nTotalMeshPrim + nMesh;
			nTotalPrim = nTotalPrim + nTotal;
			nAveErr = nAveErr+fErr;
			tInfoKeywords.append((keyword, nBox, nMesh, nTotal, fErr, evalScore));

f = open(allDatasetsDir+"/"+datasetPrefix+"_"+methodDir+".txt", "w");
f.write(str(methodDir)+"\n");
f.write(str(nCorrect)+" "+str(nPnts)+" "+str(nModels)+"\n");
keywords = sorted(keywords, key=lambda kwrd: kwrd[4], reverse=True)
for tp in keywords:
	f.write(tp[0]+" "+str(tp[1])+" "+str(tp[2])+" "+str(tp[3])+"\n")
f.close();

#f = open(allDatasetsDir+"/"+datasetPrefix+"_"+methodDir+"_tMetaInfo.txt", "w");
#f.write(str(methodDir)+"\n");
#f.write("All "+str(nTotalBoxPrim)+" "+str(nTotalMeshPrim)+" ");
#f.write(str(nTotalPrim)+" "+str(float(int(1000000*nAveErr/nTotalPrim))/1000000.)+"\n");
#tInfoKeywords = sorted(tInfoKeywords, key=lambda kwrd: kwrd[5], reverse=True);
#for tp in tInfoKeywords:
#	f.write(tp[0]+" "+str(tp[1])+" "+str(tp[2])+" "+str(tp[3])+" "+str(tp[4])+"\n")
#f.close();






