#!/usr/bin/python

##########
# aggregates labeling stats
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, time
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../largescale/"))
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../experiment/"))
import mydb, expdb

filepfx = "match";
outDirIsAbsolute = False;
processEval = False;
processMetaInfo = False;
inModelList = "none";
if len(sys.argv)>=4:
	keyword = sys.argv[1];
	outDir = sys.argv[2];
	outFile = sys.argv[3];
	i = 4;
	while (i < len(sys.argv)):
		if (sys.argv[i]=="-outDirIsAbsolute"):
			outDirIsAbsolute = True;
		elif sys.argv[i]=="-filepfx":
			i = i+1;
			filepfx = sys.argv[i];
		elif sys.argv[i]=="-processEval":
			processEval = True;
		elif sys.argv[i]=="-processMetaInfo":
			processMetaInfo = True;
		elif sys.argv[i]=="-inModelList":
			i = i+1;
			inModelList = sys.argv[i];
		else:
			print("[WARNING] Cannot understand command: "+sys.argv[i]+" in aggLabelStats");
		i = i+1;
else:
	print("Usage:");
	print("   python "+sys.argv[0]+" keyword methodDir outFile [options]");
	print("   OPTIONS:");
	print("       -outDirIsAbsolute");
	print("       -filepfx prefix");
	print("       -processEval");
	print("       -processMetaInfo");
	print("       -inModelList modelfile");
	exit();


start = time.clock();
print("Getting model list");

if inModelList=="none":
	mList = mydb.ListModels(keyword);
else:
	if not os.path.isfile(inModelList):
		print("[ERROR] Cannot find model file: "+inModelList+" aggLabelStats.py");
		exit();
	f = open(inModelList, "r");
	mList = f.readlines();
	f.close();
	mList = [mydb.NameOnly(s.strip()) for s in mList];


failures=[];
failMsg=[];
errMsg=[];
#mScore=[];
modelInfoList = [];

useSegs="Segmentation";
outMatching="";

# just in case
#mydb.WaitForAllJobs();

keyword2entry = dict();
keywords = [];
nCorrect = [];
nLabeled = [];
nGroundTruth = [];
nModels = [];

keyword2nodedescr = dict();
keywordsNodeDescr = [];
nBoxPrimitives = [];
nMeshPrimitives = [];
nTotalPrimitives = [];
fBoxFitErr = [];
nModels = [];


# write matching.txt for all matchings
if mydb.WebspaceExists():
	print("Reading all matchings");
	if not outDirIsAbsolute:
		tmpltWeb1 = mydb.Webpage(keyword)+"/Templates/"
		tmpltWeb = tmpltWeb1 + outDir+"/";
	else:
		tmpltWeb = outDir+"/";

	aveAccuracy = 0;
	nSamples = 0;
	print("NModels: "+str(len(mList)));
	for mStr in mList:
		matchedDir = tmpltWeb+mStr+"/";
		if os.path.isfile(matchedDir+filepfx+".matching.txt"):
			modelInfoList.append(expdb.ModelInst(mStr));
			matchedStr=file(matchedDir+filepfx+".matching.txt").read();
			modelInfoList[-1].energy 	  = float(re.findall("Score=(.*?)\n", matchedStr)[0]);
			modelInfoList[-1].timeStr 	  = re.findall("Time=(.*?)\n", matchedStr)[0].replace(" ", "_");
			modelInfoList[-1].seedid 	  = int(re.findall("SeedID=(.*?)\n", matchedStr)[0]);
			modelInfoList[-1].partFlags   = int(re.findall("PartFlags=(.*?)\n", matchedStr)[0]);
			modelInfoList[-1].ntmplt      = int(re.findall("TmpltSamples=(.*?)\n", matchedStr)[0]);
			modelInfoList[-1].deformDist  = float(re.findall("DeformDist=(.*?)\n", matchedStr)[0]);
		else:
			failures.append(mStr);

		if processEval and os.path.isfile(matchedDir+"eval_faces.txt"):
			lines = file(matchedDir+"eval_faces.txt").readlines();
			for line in lines:
				line = line.split(" ");
				id = len(keywords);
				if line[0] in keyword2entry:
					id = keyword2entry[line[0]];
				else:
					keywords.append(line[0]);
					nCorrect.append(0);
					nLabeled.append(0);
					nGroundTruth.append(0);
					nModels.append(0);
					keyword2entry[line[0]] = id;
				
				nCorrect[id] += float(line[1]);
				nLabeled[id] += float(line[2]);
				nGroundTruth[id] += float(line[3]);
				nModels[id] += 1;
	
		if processMetaInfo and os.path.isfile(matchedDir + "tSelfInfo.txt"):
			lines = file(matchedDir+"tSelfInfo.txt").readlines();
			lines.pop(0);
			for line in lines:
				line = line.split(" ");
				id = len(keywordsNodeDescr);
				if line[0] in keyword2nodedescr:
					id = keyword2nodedescr[line[0]];
				else:
					keywordsNodeDescr.append(line[0]);
					nBoxPrimitives.append(0);
					nMeshPrimitives.append(0);
					nTotalPrimitives.append(0);
					fBoxFitErr.append(0);
					nModels.append(0);
					keyword2nodedescr[line[0]] = id;

				if line[1]=="BoxSurface":
					nBoxPrimitives[id] = nBoxPrimitives[id] + 1;
				elif line[1]=="MeshPoints":
					nMeshPrimitives[id] = nMeshPrimitives[id] + 1;
				nTotalPrimitives[id] = nTotalPrimitives[id] + 1;
				fBoxFitErr[id] = fBoxFitErr[id] + float(line[2]);
				

	modelInfoList = sorted(modelInfoList, key=lambda mWEnergy: mWEnergy.energy);
	
	# write matching info for every model
#	print("Writing "+str(len(modelInfoList))+" models to "+tmpltWeb+outFile );
	expdb.writeModelList(modelInfoList, tmpltWeb+outFile, True);
	
	# write eval stats
	#print(tmpltWeb);
	if (len(keywords)>0):
		f = open(tmpltWeb+"eval_faces.txt", "w");
		for id in range(0, len(keywords)):
			f.write(keywords[id]+" "+str(nCorrect[id])+" "+str(nLabeled[id])+" ");
			f.write(str(nGroundTruth[id])+" "+str(nModels[id])+"\n");
		f.close();	

	# write fitting stats
	if (len(keywordsNodeDescr) > 0):
		f = open(tmpltWeb+"tSelfInfo.txt", "w");
		for id in range(0, len(keywordsNodeDescr)):
			f.write(keywordsNodeDescr[id]+" "+str(nBoxPrimitives[id])+" "+str(nMeshPrimitives[id])+" ");
			f.write(str(nTotalPrimitives[id])+" "+str(fBoxFitErr[id]) + "\n");
		f.close();

if len(failures)>0:
#	print("Failed to match: "+str(failures));
	f = open(tmpltWeb+filepfx+"failures.txt", "w");
	for id in range(0, len(keywords)):
		f.write(" ".join(failures));
	f.close();

if mydb.WebspaceExists():
	elapsed = (time.clock() - start);
	with open(tmpltWeb+"/aggTime.txt", "a") as timeFile:
		timeFile.write(outFile+" "+str(elapsed));


