//
// $Id: DEFTable.C,v 1.1 2000/01/17 18:47:40 min Exp min $
//

#include "DEFTable.h"
#include <string.h>





DEF::DEF(char *new_name, VrmlNode *new_node_ptr)
{
  name = new char[strlen(new_name) + 1];
  strcpy(name, new_name);
  vrml_node_ptr = new_node_ptr;

    // also set the "name" field of the R3Node
  R3Node *ring_ptr = vrml_node_ptr->get_ring_node_ptr();
  if (ring_ptr != NULL) ring_ptr->SetName(new_name);

}  // constructor





int
DEFTable::find_index(char *node_id)
{
  int index = DEFs.NEntries() - 1;

  if (cur_start_index >= get_size()) return -1;

  while (index >= cur_start_index) {
    if (strcmp(DEFs.Kth(index)->get_name(), node_id) == 0) return index;
    else index--;
  }  // while

  return -1;
}  // DEFTable::find_index



VrmlNode *
DEFTable::find_DEF(char *node_id)
{
  int index = find_index(node_id);

  if (index == -1)
    return NULL;
  else
    return DEFs.Kth(index)->get_vrml_node_ptr();

}  // DEFTable::find_DEF



void
DEFTable::remove(char *node_id)
{
  int index = find_index(node_id);

  if (index >= 0)
    DEFs.RemoveKth(index);

}  // DEFTable::remove



void
DEFTable::store_state()
{
  states_stored.Insert(get_size());
  cur_start_index = get_size();
}  // DEFTable::store_state



void
DEFTable::restore_state()
{
  if (states_stored.NEntries() == 0) {
    cerr << "Error: DEFTable::restore_state called before store_state"
      << endl;
    return;
  }

  int cur_size = get_size();
  int to_be_removed = cur_size - states_stored.Tail();
  for(int i=0; i<to_be_removed; i++) DEFs.RemoveTail();
  states_stored.RemoveTail();
  
  if (states_stored.NEntries() == 0) cur_start_index = 0;
  else cur_start_index = states_stored.Tail();

}  // DEFTable::restore_state


