//
// $Id: DEFTable.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __DEFTABLE_H
#define __DEFTABLE_H

#include "R3Graphics/R3Graphics.h"
#include "VrmlNode.h"

static const int MAX_NODEID_LENGTH = 128;





//
// class to store DEF'd info: name and pointer to VrmlNode
//

class DEF
{

public:

  DEF(char *new_name, VrmlNode *new_node_ptr);
  ~DEF() {
    if (name) delete name;
  }  // destructor


  char *get_name() { return name; }
  VrmlNode *get_vrml_node_ptr() { return vrml_node_ptr; }


private:

  char *name;
  VrmlNode *vrml_node_ptr;

};  // DEF class





class DEFTable
{

public:

  DEFTable() {
    cur_start_index = 0;
  }  // constructor

  ~DEFTable() {
    int nr_defs = DEFs.NEntries();
    for(int i=0; i<nr_defs; i++) delete DEFs.Kth(i);
  }  // destructor


  void add(DEF *new_def) { DEFs.Insert(new_def); }
  void remove(char *node_id);
  int get_size() { return DEFs.NEntries(); }

  void store_state();
  void restore_state();

  VrmlNode *find_DEF(char *node_id);


private:

  int find_index(char *node_id);
  int cur_start_index;

  RNArray<DEF *> DEFs;

  RNArray<int> states_stored;


};  // DEFTable class


#endif

