//
// $Id: GeometricProperties.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __GEOMETRIC_PROPERTIES_H
#define __GEOMETRIC_PROPERTIES_H

#include "VrmlNode.h"
#include "Fields.h"





class Coordinate : public VrmlNode
{

public:

  Coordinate() { 
    set_node_name("Coordinate"); 
    set_node_type(CoordinateType); 

    add_field("point", &point, exposedField);

  }  // constructor

  ~Coordinate() {}


  void sendEventIn(int field_id, void *new_value);

  SFVec3f *operator[](int index) { return (SFVec3f *) point[index]; }
  int get_size() { return point.get_size(); }

  USE_ActionType get_USE_action() { return ReturnVrmlNode; }


private:

  MFVec3f point;


};  // Coordinate class





class Color : public VrmlNode
{

public:

  Color() { 
    set_node_name("Color"); 
    set_node_type(ColorType); 

    add_field("color", &color, exposedField);

  }  // constructor

  ~Color() {}


  void sendEventIn(int field_id, void *new_value);

  USE_ActionType get_USE_action() { return ReturnVrmlNode; }


private:

  MFColor color;


};  // Color class





class Normal : public VrmlNode
{

public:

  Normal() { 
    set_node_name("Normal"); 
    set_node_type(NormalType); 

    add_field("vector", &vector, exposedField);

  }  // constructor

  ~Normal() {}


  void sendEventIn(int field_id, void *new_value);

  SFVec3f *operator[](int index) { return (SFVec3f *) vector[index]; }

  USE_ActionType get_USE_action() { return ReturnVrmlNode; }


private:

  MFVec3f vector;


};  // Normal class





class TextureCoordinate : public VrmlNode
{

public:

  TextureCoordinate() { 
    set_node_name("TextureCoordinate"); 
    set_node_type(TextureCoordinateType);

    add_field("point", &point, exposedField);

  }  // constructor

  ~TextureCoordinate() {}


  void sendEventIn(int field_id, void *new_value);

  SFVec2f *operator[](int index) { return point[index]; }
  int get_size() { return point.get_size(); }

  USE_ActionType get_USE_action() { return ReturnVrmlNode; }


private:

  MFVec2f point;

};  // TextureCoordinate class


#endif



