//
// $Id: PROTONodes.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __PROTONODES_H
#define __PROTONODES_H

#include "VrmlNode.h"
#include "VsSymbolTable.h"

class PROTO;
extern PROTO *current_proto;

extern VsSymbolTable PROTOVarTable;





class PROTO : public VrmlNode
{

public:

  PROTO();
  PROTO(PROTO& other);

  ~PROTO();


  void parse();

  USE_ActionType get_USE_action() { return ReturnFirstVrmlNode; }
  VrmlNode *get_first_node_ptr() { return first_node_ptr; }

  char *get_body_text() { return body_text; }
  VsSymbolTable& get_default_fields() { return *default_fields; }

  void instantiate();

  void sendEventIn(int field_id, void *new_value);


protected:

  void parse_fields();

  VsSymbolTable *default_fields;

  void parse_body();
  char *body_text;
  VrmlNode *first_node_ptr;  // for DEF and USE of PROTOs, see instantiate()

  void parse_parameters();


};  // PROTO class





class EXTERNPROTO : public PROTO
{

public:

  EXTERNPROTO() : PROTO() {
    set_node_type(EXTERNPROTOType);
  }
  ~EXTERNPROTO() {}


  void parse();


private:

  MFString url;


};  // EXTERNPROTO class





class PROTOList
{

public:

  PROTOList() {}
  ~PROTOList() {}


  void add_PROTO(PROTO *new_PROTO) {
    PROTOs.Insert(new_PROTO);
  }

  PROTO *find_PROTO(char *nodename);


private:

  RNArray<PROTO *> PROTOs;


};  // PROTOList class


#endif




