//
// $Id: WallTimer.C,v 1.1 2000/01/17 18:47:40 min Exp min $
//

#include "RNBasics/RNCompat.h"
#if (RN_OS == RN_IRIX)
#include <sys/time.h>
#else
#include <time.h>
#include <sys/timeb.h>
#endif

#include "WallTimer.h"





void
WallTimer::start()
{
#if (RN_OS == RN_WINDOWSNT)
  struct _timeb timeb;
  stopped = 0;

  _ftime(&timeb);
  start_sec = timeb.time;
  start_microsec = timeb.millitm * 1000;
  secs_since_1970 = start_sec;

#else
  struct timeval t;
  struct timezone tz;
  stopped = 0;

  //#if (RN_OS == RN_IRIX)
  //  gettimeofday(&t);
  //#else
  gettimeofday(&t, &tz);
  //#endif

  time(&secs_since_1970);
  secs_since_1970 -= 876e6;
  start_sec = t.tv_sec;
  start_microsec = t.tv_usec;
#endif  
}  // WallTimer::start



void
WallTimer::stop()
{
  read();
  stopped = 1;
}  // WallTimer::stop



ostream&
operator <<(ostream& out_stream, WallTimer& T)
{
  double elapsed = T.read();
  out_stream << elapsed;
  return out_stream;
}  // WallTimer operator <<



double
WallTimer::read()
{
  if (!stopped) {
#if (RN_OS == RN_WINDOWSNT)
    struct _timeb timeb;
    
    _ftime(&timeb);
    elapsed = (double)(timeb.time - start_sec) +
      (double)(timeb.millitm * 1000 - start_microsec)/1000000.0;
#else
    struct timeval t;
    struct timezone tz;

    //#if (RN_OS == RN_IRIX)
    //    gettimeofday(&t);
    //#else
    gettimeofday(&t, &tz);
    //#endif
    
    elapsed = (double)(t.tv_sec - start_sec) + 
      (double)(t.tv_usec - start_microsec)/1000000.0;// + prev_elapsed;
#endif
  }

  return elapsed;
}  // WallTimer::read



double
WallTimer::last_read()
{
  return elapsed;
}  // WallTimer::last_read



double
WallTimer::read_since_1970()
{
  return read() + (double) secs_since_1970;
}  // WallTimer::read_since_1970



double
WallTimer::last_read_since_1970()
{
  return elapsed + (double) secs_since_1970;
}  // WallTimer::last_read_since_1970


